﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DynamicQueries.WinApp.Cfg
{
    public class Condition
    {
        public Dictionary<string, ConditionItem> Fields { get; set; }
        public Condition()
        {
            Fields = new Dictionary<string, ConditionItem>();
        }

        public void Save()
        {
            string file = getFilePath();
            JsonHelper.Save(this, file);
        }

        public static Condition FromFile()
        {
            Condition? condition =  JsonHelper.FromFile<Condition>(getFilePath());
            if(condition == null)
            {
                condition = new Condition();
            }
            return condition;
        }

        public static string getFilePath()
        {
            return System.IO.Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "cfg", "conditions.json");
        }
    }
}
