﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DynamicQueries.WinApp.Cfg
{
    public class FieldItem
    {
        public string Title { get;set; }
        public string FieldName { get;set; }
        public string FieldType {  get;set; }

        public FieldItem() { }

        public override string ToString()
        {
            return Title;
        }

        public static List<FieldItem> GetAppConfigFields()
        {
            string path = Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "cfg", "Fields.json");
            var fields = JsonHelper.FromFile<List<FieldItem>>(path);
            if(fields == null)//没有的话，需要生成首份配置字段
            {
                fields = new List<FieldItem>();
                fields.Add(new FieldItem() { FieldName = "VisitName", Title = "姓名", FieldType = "String" });
                fields.Add(new FieldItem() { FieldName = "Age", Title = "年龄", FieldType = "Int" });
                fields.Add(new FieldItem() { FieldName = "InDate", Title = "入院时间", FieldType = "DateTime" });
                JsonHelper.Save(fields, path);
            }
            return fields;
        }
    }
}
