﻿using DynamicQueries.WinApp.Cfg;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using static System.Windows.Forms.VisualStyles.VisualStyleElement;

namespace DynamicQueries.WinApp.FieldViews
{
    public partial class DateTimeCtl : UserControl
    {
        public DateTimeCtl(FieldItem field, DateTimeValues? values)
        {
            InitializeComponent();
            label1.Text = field.Title;
            if (values != null)
            {
                comboBox1.Text = values.Act;
                dateTimePicker1.Value = values.Start;
                dateTimePicker2.Value = values.End;
            }
        }
        public DateTimeValues ReadCondition()
        {
            var values = new DateTimeValues();
            values.Title = label1.Text;
            values.Act = comboBox1.Text;
            values.Start = dateTimePicker1.Value;
            values.End = dateTimePicker2.Value;
            return values;
        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (this.comboBox1.Text == "区间")
            {
                label2.Visible = true;
                dateTimePicker2.Visible = true;
            }
            else
            {
                label2.Visible = false;
                dateTimePicker2.Visible = false;
            }
        }
    }

    public class DateTimeValues
    {
        public string? Title { get; set; }
        public DateTime Start { get; set; }
        public DateTime End { get; set; }
        public string? Act { get; set; }
    }
}
