﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;

namespace DynamicQueries.WinApp.FieldViews
{
    public class DictValues
    {
        private Dictionary<string,string> values;

        public DictValues(string json)
        {
            var temp = JsonHelper.FromJson<Dictionary<string,string>>(json);
            if (temp != null)
                values = temp;
            else
                values = new Dictionary<string,string>();
        }

        public string this[string key]
        {
            get
            {
                if (values.ContainsKey(key))
                    return values[key];
                else
                    return string.Empty;
            }
            set { values[key] = value; }
        }
        public void Add(string  key, string value)
        {
            values.Add(key, value);
        }

        public string ToJson()
        {
            return JsonHelper.ToJson(this.values);
        }
    }
}
