﻿using DynamicQueries.WinApp.Cfg;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace DynamicQueries.WinApp.FieldViews
{
    public partial class IntCtl : UserControl
    {
        public IntCtl(FieldItem field, string condition)
        {
            InitializeComponent();
            label1.Text = field.Title;
            init(condition);
        }
        private void init(string condition)
        {
            var values = new DictValues(condition);
            if (values != null)
            {
                comboBox1.Text = values["act"];
                textBox1.Text = values["val1"];
                textBox2.Text = values["val2"];
            }
        }

        public ConditionItem ReadCondition()
        {
            var values = new DictValues(string.Empty);
            values.Add("act", comboBox1.Text);
            values.Add("val1", textBox1.Text);
            values.Add("val2", textBox2.Text);
            var result = new ConditionItem();
            result.Condition = values.ToJson();
            if (comboBox1.Text == "区间")
                result.Desc = $"{label1.Text}{textBox1.Text}至{textBox2.Text}";
            else
                result.Desc = $"{label1.Text}{comboBox1.Text}{textBox1.Text}";
            return result;
        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (this.comboBox1.Text == "区间")
            {
                label2.Visible = true;
                textBox2.Visible = true;
            }
            else
            {
                label2.Visible = false;
                textBox2.Visible = false;
            }
        }
    }
}
