﻿using DynamicQueries.WinApp.Cfg;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace DynamicQueries.WinApp.FieldViews
{
    public partial class StringCtl : UserControl
    {
        public StringCtl(FieldItem field, string condition)
        {
            InitializeComponent();
            label1.Text = field.Title;
            init(condition);
        }
        private void init(string condition)
        {
            Dictionary<string, string>? values = JsonHelper.FromJson<Dictionary<string, string>>(condition);
            if (values != null)
            {
                comboBox1.Text = values["act"];
                textBox1.Text = values["val"];
            }
        }

        public ConditionItem ReadCondition()
        {
            Dictionary<string, string> values = new Dictionary<string, string>();
            values.Add("act", comboBox1.Text);
            values.Add("val", textBox1.Text);
            var result = new ConditionItem();
            result.Condition = JsonHelper.ToJson(values);
            result.Desc = $"{label1.Text}{comboBox1.Text}{textBox1.Text}";
            return result;
        }
    }
}
