﻿using DynamicQueries.WinApp.Cfg;
using DynamicQueries.WinApp.FieldViews;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace DynamicQueries.WinApp.Fields
{
    /// <summary>
    /// 日期类型字段
    /// </summary>
    public class DateTimeField : IFieldController
    {
        public string HandleType => "DateTime";

        public Control BuildFieldEditor(FieldItem field, string condition)
        {
            var values = JsonHelper.FromJson<DateTimeValues>(condition);
            return new DateTimeCtl(field,values);
        }

        public void BuildWhere(SqlBuilder build, FieldItem field, string condition)
        {
            var values = JsonHelper.FromJson<DateTimeValues>(condition);
            if (values == null)
                return;

            if (values.Act == "区间")
                build.AndBetween(field.FieldName,values.Start,values.End);
            else
                build.And(values.Act!, field.FieldName, values.Start);
        }

        public ConditionItem ReadCondition(Control ctrol)
        {
            var ctl = (DateTimeCtl)ctrol;
            var values = ctl.ReadCondition();
            var result = new ConditionItem();
            result.Condition = JsonHelper.ToJson(values);
            if (values.Act == "区间")
                result.Desc = $"{values.Title}{values.Start:yyyy-MM-dd}至{values.End:yyyy-MM-dd}";
            else
                result.Desc = $"{values.Title}{values.Act}{values.Start:yyyy-MM-dd}";
            return result;
        }
    }
}
