﻿using DynamicQueries.WinApp.FieldViews;
using Microsoft.VisualBasic.FileIO;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;

namespace DynamicQueries.WinApp.Fields
{
    public class FieldFacotry
    {
        static Dictionary<string, IFieldController> fields = new Dictionary<string, IFieldController>();
        public static IFieldController GetFieldType(string fieldType)
        {
            IFieldController? result = null;
            if(fields.ContainsKey(fieldType))
            {
                result = fields[fieldType];
            }
            if(result==null)
                return new StringField();
            else
                return result;
        }

        static FieldFacotry()
        {
            Type targetType = typeof(IFieldController);
            Type[] types = Assembly.GetExecutingAssembly().GetTypes();
            foreach (Type type in types)
            {
                if (!type.IsClass)
                    continue;
                if (targetType.IsAssignableFrom(type))
                {                    
                    var obj = Activator.CreateInstance(type);
                    var result = obj as IFieldController;
                    if (result == null)
                        continue;
                    fields[result.HandleType] = result;
                }
            }
        }
    }
}
