﻿using DynamicQueries.WinApp.Cfg;
using DynamicQueries.WinApp.Fields;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace DynamicQueries.WinApp
{
    public partial class FormCondtion : Form
    {
        public FormCondtion()
        {
            InitializeComponent();
        }
        /// <summary>
        /// 所有字段定义
        /// </summary>
        Dictionary<string, FieldItem> dictField = new Dictionary<string, FieldItem>();
        private void FormCondtion_Load(object sender, EventArgs e)
        {
            var fields = FieldItem.GetAppConfigFields();
            var conds = Condition.FromFile();
            foreach (var field in fields)
            {
                dictField[field.FieldName] = field;//保存所有字段定义
                //分别放在两个列表中
                if (conds.Fields.ContainsKey(field.FieldName))
                    listCondition.Items.Add(conds.Fields[field.FieldName]);
                else
                    listFields.Items.Add(field);
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            moveFieldToCondition();
        }
        private void moveFieldToCondition()
        {
            FieldItem field = (FieldItem)listFields.SelectedItem;
            listFields.Items.Remove(field);
            ConditionItem item = new ConditionItem();
            item.Desc = field.Title;
            item.FieldName = field.FieldName;
            listCondition.Items.Add(item);
            saveCondition();
        }

        private void saveCondition()
        {
            if (lastConditionEditing != null)
            {
                var condition = lastConditionEditing.Field.ReadCondition(splitContainer1.Panel2.Controls[0]);
                lastConditionEditing.SetCondition(condition);//回填条件
            }
            var conds = new Condition();//从列表中重新构造
            foreach (ConditionItem cnd in listCondition.Items)
            {
                conds.Fields[cnd.FieldName] = cnd;
            }
            conds.Save();
        }
        private void listFields_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            moveFieldToCondition();
        }

        ConditionEditing? lastConditionEditing;
        private void listCondition_SelectedIndexChanged(object sender, EventArgs e)
        {
            //改变时需要先保存一下当前查询范围
            saveCondition();
            ConditionItem? item = listCondition.SelectedItem as ConditionItem;
            if (item == null)
                return;
            //取出当前设置的字段
            FieldItem field = dictField[item.FieldName];
            //取出字段适用的控制器
            var controller = FieldFacotry.GetFieldType(field.FieldType);
            //通过控制器取出范围录入界面
            Control ctl = controller.BuildFieldEditor(field, item.Condition);
            //将控件换到用户界面
            splitContainer1.Panel2.Controls.Clear();
            splitContainer1.Panel2.Controls.Add(ctl);
            //保存为最后的编辑项，以备切换时，保存的动作会使用该属性。
            lastConditionEditing = new ConditionEditing(controller, item);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            saveCondition();
            this.DialogResult = DialogResult.OK;
            this.Close();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            ConditionItem? condition = listCondition.SelectedItem as ConditionItem;
            if (condition == null) return;

            listCondition.Items.Remove(condition);

            var field = dictField[condition.FieldName];
            listFields.Items.Add(field);
            saveCondition();
        }
    }
}
