﻿using DynamicQueries.WinApp.Cfg;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DynamicQueries.WinApp
{
    public interface IFieldController
    {
        /// <summary>
        /// 处理的字段类型
        /// </summary>
        string HandleType { get; }
        /// <summary>
        /// 获取查询范围编辑器
        /// </summary>
        /// <param name="field"></param>
        /// <param name="condition"></param>
        /// <returns></returns>
        Control BuildFieldEditor(FieldItem field, string condition);
        /// <summary>
        /// 读取查询范围
        /// </summary>
        /// <param name="ctrol"></param>
        /// <returns></returns>
        ConditionItem ReadCondition(Control ctrol);
        /// <summary>
        /// 生成where条件
        /// </summary>
        /// <param name="build"></param>
        /// <param name="field"></param>
        /// <param name="condition"></param>
        void BuildWhere(SqlBuilder build, FieldItem field, string condition);
    }
}
