﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.Encodings.Web;
using System.Text.Json;
using System.Text.Unicode;
using System.Threading.Tasks;

namespace DynamicQueries.WinApp
{
    public class JsonHelper
    {
        public static void Save(object obj, string path)
        {
            string json = ToJson(obj);
            System.IO.FileInfo file = new System.IO.FileInfo(path);
            if (file.Directory!.Exists == false)
                file.Directory!.Create();
            System.IO.File.WriteAllText(path, json);
        }

        public static string ToJson(object obj)
        {
            var jsonOptions = new JsonSerializerOptions()
            {
                WriteIndented = true,
                PropertyNameCaseInsensitive = true,
                Encoder = JavaScriptEncoder.Create(UnicodeRanges.BasicLatin, UnicodeRanges.CjkUnifiedIdeographs)
            };
            return JsonSerializer.Serialize(obj, jsonOptions);
        }
        public static T? FromJson<T>(string json)
        {
            if (string.IsNullOrEmpty(json))
                return default(T);

            return JsonSerializer.Deserialize<T>(json);
        }

        public static T? FromFile<T>(string path)
        {
            if (!System.IO.File.Exists(path))
                return default(T);

            string json = System.IO.File.ReadAllText(path);
            return FromJson<T>(json);
        }
    }
}
