﻿using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DynamicQueries.WinApp
{
    public class SqlBuilder:IDisposable
    {
        StringBuilder mSqlCode = new StringBuilder();        
        SqlCommand mCmd = new SqlCommand();
        bool isFirst = true;
        public void And(string sql, Dictionary<string, object> parameters)
        {
            addSql("and", sql);
            foreach (var one in parameters)
                mCmd.Parameters.Add(new SqlParameter(one.Key, one.Value));
        }

        private void addSql(string join,string sql) { 
            if(isFirst)
                mSqlCode.Append(sql);
            else
                mSqlCode.Append($" {join} {sql}");
            isFirst = false;
        }
        public void And(string act,string field,object val)
        {
            string? sql = null;
            switch (act)
            {
                case "大于":
                    sql = $"{field}>@{field}";
                    break;
                case "小于":
                    sql = $"{field}<@{field}";
                    break;
                default:
                    sql = $"{field}=@{field}";
                    break;
            }
            addSql("and", sql);
            mCmd.Parameters.Add(new SqlParameter(field, val));
        }

        public void AndBetween(string field, object val1,object val2)
        {
            string parStart = $"{field}_Start";
            string parEnd = $"{field}_End";
            Dictionary<string, object> dict = new Dictionary<string, object>();
            dict.Add(parStart, val1);
            dict.Add(parEnd, val2);
            And($"{field}>=@{parStart} and {field}<=@{parEnd}", dict);
        }

        public void Dispose()
        {
            mCmd.Dispose();
        }

        public SqlCommand GetQueryCommand(SqlConnection conn,string fields,string tablename)
        {
            mCmd.Connection = conn;
            mCmd.CommandText = string.Format("selct {0} from {1} where {2}", fields, tablename, mSqlCode.ToString());
            return mCmd;
        }
    }
}
